package com.jiuqi.util;

package .tmp;

import java.io.Serializable;

public class IntBits implements Serializable {
  private static final int[] TrueMarke = new int[] { 
      1, 2, 4, 8, 16, 32, 64, 128, 256, 512, 
      1024, 2048, 4096, 8192, 16384, 32768, 65536, 131072, 262144, 524288, 
      1048576, 2097152, 4194304, 8388608, 16777216, 33554432, 67108864, 134217728, 268435456, 536870912, 
      1073741824, Integer.MIN_VALUE };
  
  private static final int[] FalseMarke = new int[] { 
      -2, -3, -5, -9, -17, -33, -65, -129, -257, -513, 
      -1025, -2049, -4097, -8193, -16385, -32769, -65537, -131073, -262145, -524289, 
      -1048577, -2097153, -4194305, -8388609, -16777217, -33554433, -67108865, -134217729, -268435457, -536870913, 
      -1073741825, Integer.MAX_VALUE };
  
  private int b = 0;
  
  public boolean get(int index) {
    return ((this.b >>> index - 1 & 0x1) == 1);
  }
  
  public void set(int index, boolean value) {
    this.b = value ? (this.b | TrueMarke[index - 1]) : (this.b & FalseMarke[index - 1]);
  }
  
  public int getValue() {
    return this.b;
  }
  
  public void setValue(int value) {
    this.b = value;
  }
  
  public static void main(String[] args) {
    com.jiuqi.util.IntBits intBits = new com.jiuqi.util.IntBits();
    intBits.setValue(0);
    int i;
    for (i = 1; i < 33; i++) {
      System.out.println(Integer.toBinaryString(intBits.getValue()));
      intBits.set(i, true);
    } 
    for (i = 32; i > 0; i--) {
      intBits.set(i, false);
      System.out.println(Integer.toBinaryString(intBits.getValue()));
    } 
  }
}
